#include <QGuiApplication>
#include <QQmlApplicationEngine>
#include <QFile>
#include <QDebug>
#include <QQmlContext>

class TextFile : public QObject
{
    Q_OBJECT
    Q_PROPERTY(QString text READ text CONSTANT)

public:
    TextFile()
    {
        QFile textFile(":/big.txt");
        if (!textFile.open(QIODevice::ReadOnly)) {
            qWarning() << "failed to open text file";
            return;
        }

        mText = textFile.readAll();
    }

    QString text() {
        return mText;
    }

private:
    QString mText;
};

int main(int argc, char *argv[])
{
    QCoreApplication::setAttribute(Qt::AA_EnableHighDpiScaling);

    QGuiApplication app(argc, argv);

    TextFile textFile;

    QQmlApplicationEngine engine;
    engine.rootContext()->setContextProperty("textFile", &textFile);

    const QUrl url(QStringLiteral("qrc:/main.qml"));
    QObject::connect(&engine, &QQmlApplicationEngine::objectCreated,
                     &app, [url](QObject *obj, const QUrl &objUrl) {
        if (!obj && url == objUrl)
            QCoreApplication::exit(-1);
    }, Qt::QueuedConnection);
    engine.load(url);

    return app.exec();
}

#include "main.moc"
